%define	snap 20050529
%define bs_ver 0.2.0-RC8f-CVS

%define	major 1
%define libname	%mklibname tonezone %{major}

%define	progs	fxstest hdlcgen hdlcstress hdlctest hdlcverify makefw patgen patlooptest pattest usbfxstest wct4xxp-diag ztcfg ztdiag ztmonitor ztspeed zttool timertest torisatool fxotune
# ztprovision ztcat ztcfg-dude fxsdump sethdlc 

Summary:	Zapata Telephony Interface Library and tools
Name:		zaptel
Version:	1.1
Release:	%mkrel 0.%{snap}.2
License:	GPL
Group:		System/Libraries
URL:		http://www.asterisk.org/
Source0:	http://www.asterisk.org/html/downloads/%{name}-%{version}-%{snap}.tar.bz2
Source1:	zaptel.init.bz2
Source2:	zaptel.sysconfig.bz2
Source3:	modprobe.conf.bz2
Source4:	http://www.junghanns.net/asterisk/downloads/bristuff-%{bs_ver}.tar.bz2
Patch0:		zaptel-1.0.8-20050529-mdk.diff.bz2
Patch1:		zaptel-1.0.8-20050529-lvalues_fix.diff.bz2
Patch2:		zaptel-1.1-20050529-pciradio_x86_64_fix.diff
BuildRequires:	newt-devel
BuildRequires:	%{mklibname zap 1}-devel >= 1.0.1
BuildConflicts:	%{mklibname tonezone %{major}}-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
Zapata Telephony Interface Library and utilities

The Zapata Telephony Interface drivers is contained in the 
kernel-zaptel (or dkms) package.

BRI support was added from the bri-stuff-%{bs_ver} tarball by
Klaus-Peter Junghanns: http://www.junghanns.net/

%package -n	%{libname}
Summary:	The shared Zapata Telephony Interface Library
Group:          System/Libraries

%description -n	%{libname}
The shared Zapata Telephony Interface Library

The Zapata Telephony Interface drivers is contained in the 
kernel-zaptel (or dkms) package.

BRI support was added from the bri-stuff-%{bs_ver} tarball by
Klaus-Peter Junghanns: http://www.junghanns.net/

%package -n	%{libname}-devel
Summary:	Development files for the Zapata Telephony Interface Library
Group:		Development/C
Obsoletes:	%{name}-devel libtonezone-devel
Provides:	%{name}-devel libtonezone-devel
Requires:	%{libname} = %{version}

%description -n	%{libname}-devel
Development files for the Zapata Telephony Interface Library.

This package contains the static tonezone library and its header
files.

%package -n	dkms-%{name}
Summary:	Kernel drivers for the Zapata Telephony Interface
Group:		System/Kernel and hardware
#PreReq:		rpm-helper
Requires:	dkms
Requires:	zaptel-tools = %{version}
Requires:	sethdlc >= 1.15

%description -n	dkms-%{name}

Kernel drivers for the Zapata Telephony Interfaces:


 o tor2 - T400P - Quad Span T1 Card
          E400P - Quad Span E1 Card
 o wct4xxp - TE405P - Quad Span T1/E1 Card (5v version)
             TE410P - Quad Span T1/E1 Card (3.3v version)
 o wct1xxp - T100P - Single Span T1 Card
             E100P - Single Span E1 Card
 o wct11xp - TE110P - Single Span T1/E1 Card
 o wcfxo - X100P/X101P - Single port FXO interface
 o wctdm - TDM400P - Modular FXS/FXO interface (1-4 ports)
 o wcusb or wcfxsusb S100U - Single port FXS USB Interface
 o torisa - Old Tormenta1 ISA Card
 o ztdummy - UHCI USB Zaptel Timing Only Interface
 o pciradio - PCI RADIO Card  Zapata Telephony PCI Quad Radio 
              Interface driver

Kernel drivers for the multiBRI Interfaces:

 o qozap - Zaptel driver for the quadBRI PCI ISDN card and the
   octoBRI PCI ISDN card!
 o zaphfc - Zaptel driver for HFC-S PCI A based ISDN BRI cards
 o cwain - Zaptel driver for the Junghanns.NET E1 card
           c.w.a.i.n. == card without an interesting name
           single/double E1 board

BRI support was added from the bri-stuff-%{bs_ver} tarball by
Klaus-Peter Junghanns: http://www.junghanns.net/

%package	tools
Summary:	Various tools for the Zapata Telephony Interface
Group:          System/Kernel and hardware

%description	tools
Various tools for the Zapata Telephony Interface

%prep

%setup -q -n %{name}-%{version}-%{snap} -a4

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;
		
for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

patch -p1 < bristuff-%{bs_ver}/patches/zaptel.patch

%patch0 -p0

bzcat %{SOURCE1} > zaptel.init
bzcat %{SOURCE2} > zaptel.sysconfig
bzcat %{SOURCE3} > modprobe.conf

cp -p bristuff-%{bs_ver}/qozap/*.c .
cp -p bristuff-%{bs_ver}/qozap/*.h .
cp -p bristuff-%{bs_ver}/zaphfc/*.c .
cp -p bristuff-%{bs_ver}/zaphfc/*.h .
cp -p bristuff-%{bs_ver}/cwain/*.c .
cp -p bristuff-%{bs_ver}/cwain/*.h .

%patch1 -p0
%patch2 -p0

%build

%make RPM_OPT_FLAGS="%{optflags} -fPIC -DPIC -D_REENTRANT" libtonezone.so
%make libtonezone.a

# make these with a twist...
mkdir -p private-build
cp -p *.c *.h *.cc Makefile private-build/
cp -p libtonezone.so.%{major}.0 private-build/

pushd private-build
perl -pi -e "s|\<linux/zaptel.h\>|\"zaptel.h\"|g" *

ln -snf libtonezone.so.%{major}.0 libtonezone.so.%{major}
ln -snf libtonezone.so.%{major}.0 libtonezone.so

for prog in %progs; do
    %make RPM_OPT_FLAGS="%{optflags} -fPIC -DPIC -D_REENTRANT -L." $prog
done

%make RPM_OPT_FLAGS="%{optflags} -fPIC -DPIC -D_REENTRANT" libtonezone.a
rm -f libtonezone.so*
gcc %{optflags} -fPIC -DPIC -D_REENTRANT -o ../ztcfg-static ztcfg.o -lm -L. -ltonezone ./libtonezone.a

popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}/usr/src/%{name}-%{version}-%{release}
install -d %{buildroot}%{_sysconfdir}/sysconfig/network-scripts
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_includedir}/linux
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}/sbin

cp Makefile \
    *.c \
    *.h \
    *.rbt \
    %{buildroot}/usr/src/%{name}-%{version}-%{release}/
perl -pi -e "s|\<linux/zaptel.h\>|\"zaptel.h\"|g" %{buildroot}/usr/src/%{name}-%{version}-%{release}/*
perl -pi -e "s|\<zaptel.h\>|\"zaptel.h\"|g" %{buildroot}/usr/src/%{name}-%{version}-%{release}/*

cat > %{buildroot}/usr/src/%{name}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_VERSION="%{version}-%{release}"

# Items below here should not have to change with each driver version
PACKAGE_NAME="%{name}"
MAKE[0]="make linux26 KERNVER=$kernelver"
CLEAN="make KERNVER=$kernelver clean"

BUILT_MODULE_NAME[0]="zaptel"
BUILT_MODULE_NAME[1]="tor2"
BUILT_MODULE_NAME[2]="torisa"
BUILT_MODULE_NAME[3]="wcusb"
BUILT_MODULE_NAME[4]="wcfxo"
BUILT_MODULE_NAME[5]="wctdm"
BUILT_MODULE_NAME[6]="ztdynamic"
BUILT_MODULE_NAME[7]="ztd-eth"
BUILT_MODULE_NAME[8]="wct1xxp"
BUILT_MODULE_NAME[9]="wct4xxp"
BUILT_MODULE_NAME[10]="wcte11xp"
BUILT_MODULE_NAME[11]="pciradio"
BUILT_MODULE_NAME[12]="ztd-loc"
BUILT_MODULE_NAME[13]="ztdummy"
BUILT_MODULE_NAME[14]="qozap"
BUILT_MODULE_NAME[15]="zaphfc"
BUILT_MODULE_NAME[16]="cwain"


DEST_MODULE_LOCATION[0]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[1]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[2]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[3]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[4]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[5]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[6]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[7]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[8]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[9]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[10]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[11]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[12]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[13]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[14]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[15]="/kernel/drivers/telephony/zaptel"
DEST_MODULE_LOCATION[16]="/kernel/drivers/telephony/zaptel"

AUTOINSTALL=yes
EOF

install -m0755 libtonezone.so.%{major}.0 %{buildroot}%{_libdir}/
ln -snf libtonezone.so.%{major}.0 %{buildroot}%{_libdir}/libtonezone.so.%{major}
ln -snf libtonezone.so.%{major}.0 %{buildroot}%{_libdir}/libtonezone.so
install -m0755 libtonezone.a %{buildroot}/%{_libdir}/
install -m0644 zaptel.h %{buildroot}%{_includedir}/linux/
install -m0644 torisa.h %{buildroot}%{_includedir}/linux/
install -m0644 tonezone.h %{buildroot}%{_includedir}/linux/

for prog in %progs; do
    install -m0755 private-build/$prog %{buildroot}%{_sbindir}/
done

rm -f %{buildroot}%{_sbindir}/ztcfg
install -m0755 ztcfg-static %{buildroot}/sbin/ztcfg

install -m0755 ifup-hdlc %{buildroot}%{_sysconfdir}/sysconfig/network-scripts

# fix one conflicting file with tetex
mv %{buildroot}%{_sbindir}/patgen %{buildroot}%{_sbindir}/%{name}-patgen

#install -m0755 zaptel.init %{buildroot}%{_initrddir}/zaptel
install -m0644 zaptel.conf.sample %{buildroot}%{_sysconfdir}/zaptel.conf
#install -m0644 zaptel.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/zaptel

cp bristuff-%{bs_ver}/qozap/zaptel.conf bristuff-qozap.zaptel.conf 
cp bristuff-%{bs_ver}/qozap/zapata.conf.octoBRI bristuff-qozap.zapata.conf.octoBRI
cp bristuff-%{bs_ver}/qozap/zapata.conf bristuff-qozap.zapata.conf
cp bristuff-%{bs_ver}/qozap/zaptel.conf.octoBRI bristuff-qozap.zaptel.conf.octoBRI
cp bristuff-%{bs_ver}/zaphfc/zaptel.conf bristuff-zaphfc.zaptel.conf
cp bristuff-%{bs_ver}/zaphfc/zapata.conf bristuff-zaphfc.zapata.conf
cp bristuff-%{bs_ver}/qozap/TODO bristuff-TODO
cp bristuff-%{bs_ver}/INSTALL bristuff-INSTALL
cp bristuff-%{bs_ver}/CHANGES bristuff-CHANGES
cp bristuff-%{bs_ver}/cwain/TODO bristuff-cwain.TODO
#cp bristuff-%{bs_ver}/cwain/zapata.conf bristuff-cwain.zapata.conf
#cp bristuff-%{bs_ver}/cwain/zapata.conf.doubleE1 bristuff-cwain.zapata.conf.doubleE1
#cp bristuff-%{bs_ver}/cwain/zaptel.conf bristuff-cwain.zaptel.conf
#cp bristuff-%{bs_ver}/cwain/zaptel.conf.doubleE1 bristuff-cwain.zaptel.conf.doubleE1

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%post -n dkms-%{name}
dkms add -m	%{name} -v %{version}-%{release} --rpm_safe_upgrade
dkms build -m	%{name} -v %{version}-%{release} --rpm_safe_upgrade
dkms install -m	%{name} -v %{version}-%{release} --rpm_safe_upgrade
#%%_post_service zaptel

%preun -n dkms-%{name}
dkms remove -m	%{name} -v %{version}-%{release} --rpm_safe_upgrade --all
#%%_preun_service zaptel

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%doc ChangeLog README
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%{_includedir}/linux/*.h
%{_libdir}/*.so
%{_libdir}/*.a

%files -n dkms-%{name}
%defattr(-,root,root)
%doc modprobe.conf README* bristuff-qozap.* bristuff-zaphfc.* udev/*
#%doc bristuff-cwain.*
%doc bristuff-%{bs_ver}/SAMPLES bristuff-TODO
%doc bristuff-INSTALL bristuff-CHANGES
#%attr(0755,root,root) %{_initrddir}/zaptel
%attr(0755,root,root) %{_sysconfdir}/sysconfig/network-scripts/ifup-hdlc
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/zaptel.conf
#%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/zaptel
/usr/src/%{name}-%{version}-%{release}

%files tools
%defattr(-,root,root)
%attr(0755,root,root) /sbin/ztcfg
%attr(0755,root,root) %{_sbindir}/fxstest
%attr(0755,root,root) %{_sbindir}/fxotune
%attr(0755,root,root) %{_sbindir}/hdlcgen
%attr(0755,root,root) %{_sbindir}/hdlcstress
%attr(0755,root,root) %{_sbindir}/hdlctest
%attr(0755,root,root) %{_sbindir}/hdlcverify
%attr(0755,root,root) %{_sbindir}/makefw
%attr(0755,root,root) %{_sbindir}/patlooptest
%attr(0755,root,root) %{_sbindir}/pattest
%attr(0755,root,root) %{_sbindir}/timertest
%attr(0755,root,root) %{_sbindir}/torisatool
%attr(0755,root,root) %{_sbindir}/usbfxstest
%attr(0755,root,root) %{_sbindir}/wct4xxp-diag
%attr(0755,root,root) %{_sbindir}/zaptel-patgen
%attr(0755,root,root) %{_sbindir}/ztdiag
%attr(0755,root,root) %{_sbindir}/ztmonitor
%attr(0755,root,root) %{_sbindir}/ztspeed
%attr(0755,root,root) %{_sbindir}/zttool

%changelog
* Fri Sep 02 2005 Oden Eriksson <oeriksson@mandriva.com> 1.1-20050529.2mdk
- fix build on x86_64 (#17971)
- use sane dep names

* Wed Jun 29 2005 Oden Eriksson <oeriksson@mandriva.com> 1.1-20050529.1mdk
- use a more appropriate version because this is really HEAD and not 1.0.8

* Tue Jun 21 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050529.3mdk
- fixed P1 (couriousous, Stefan van der Eijk)

* Mon Jun 20 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050529.2mdk
- removed usless stuff in P0
- added P1 to make the zaphfc module compile (is this correct?)

* Tue May 31 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050529.1mdk
- new snap (20050529)
- rediff P0
- bristuff-0.2.0-RC8f-CVS

* Thu May 05 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050420.3mdk
- rebuilt with gcc4

* Thu Apr 28 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050420.2mdk
- 0.2.0-RC8a-CVS
- mention the bristuff version in the description
- added the cwain driver from bristuff

* Wed Apr 27 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.8-0.20050420.1mdk
- use a recent CVS snap

* Fri Apr 22 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.7-3mdk
- never release without that first cup of morning coffey...

* Thu Apr 21 2005 Oden Eriksson <oeriksson@mandriva.com> 1.0.7-2mdk
- added the config to the dkms package
- relocate binaries to %%{_sbindir}/
- build the ztcfg binary statically and put it in /sbin/
- provide a sample of a modprobe.conf file, as generated in 
  a make install
- fix deps
- added the ifup-hdlc script
- added the qozap and zaphfc drivers from bristuff

* Wed Mar 30 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.7-1mdk
- 1.0.7

* Sun Mar 13 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.6-1mdk
- 1.0.6
- use the %%mkrel macro
- update P0 to bristuff-0.2.0-RC7k
- drop obsolete patches P2 and P3

* Sat Jan 22 2005 Stefan van der Eijk <stefan@eijk.nu> 1.0.3-4mdk
- fix wcfxs module compile with new gcc & kernel

* Tue Jan 11 2005 Stefan van der Eijk <stefan@eijk.nu> 1.0.3-3mdk
- fix dkms naming

* Thu Jan 06 2005 Stefan van der Eijk <stefan@eijk.nu> 1.0.3-2mdk
- add dkms package

* Sun Dec 26 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.3-1mdk
- 1.0.3
- bristuff-0.2.0-RC3 (P0)
- rediff P1
- drop the sethdlc binary as the code is too old. use the new
  sethdlc-1.15 >= 1mdk package instead.

* Wed Nov 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.2-3mdk
- bristuff-0.2.0-rc2a

* Mon Nov 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.2-2mdk
- bristuff-0.2.0-rc2 (P1)

* Wed Oct 27 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.2-1mdk
- 1.0.2
- better and updated P0
- bristuff-0.2.0-rc1 (P1)

* Sun Sep 26 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-2mdk
- added P1 by Klaus-Peter Junghanns

* Fri Sep 24 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-1mdk
- 1.0.0
- fix url

* Sat Sep 11 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.RC2.2mdk
- fix one conflicting file with tetex

* Sat Sep 11 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.RC2.1mdk
- initial mandrake package
